//+------------------------------------------------------------------+
//|                                             History analysis.mq4 |
//|                                                    Steve Hopwood |
//|                                     www.hopwood3,freeserve.co.uk |
//+------------------------------------------------------------------+
#property copyright "Steve Hopwood"
#property link      "www.hopwood3,freeserve.co.uk"
#include <WinUser32.mqh>
#include <stdlib.mqh>
#define  NL    "\n"

/*
int start()
void ShowData(int mn, string det);
Void CreateArray()
void AnalyseTrades()


*/

extern int        MagicNumber1=1592820;
extern string     Description1="DTRT";
extern int        MagicNumber2=563656;
extern string     Description2="TBL";
extern int        MagicNumber3=7183149;
extern string     Description3="10 A DAY";
extern int        MagicNumber4=615046;
extern string     Description4="Round";
extern int        MagicNumber5=4971887;
extern string     Description5="2ma macd";
extern int        MagicNumber6=6381345;
extern string     Description6="5mm";
extern int        MagicNumber7=106422;
extern string     Description7="Monica";
extern int        MagicNumber8=6224179;
extern string     Description8="HTCB";
extern int        MagicNumber9=-1;
extern string     Description9;
extern int        MagicNumber10=-1;
extern string     Description10;

extern string     dins="----Pair display settings----";
extern color      PairColour=Yellow;
extern color      TradesColour=Turquoise;
extern color      WinColour=Green;
extern color      LossColour=Red;
extern color      BreakevenColour=Turquoise;
extern double     DisplayHorizontalStart=100;
extern int        HorizontalIncrement=50;
extern double     DisplayVerticalStart=5.2;
extern int        VerticalIncrement=2.5;
extern int        FontSize=10;
      
int               OrdersInHistory=0;

//These variable to turn the user input into arrays
int               MagicNumber[10];
string            Description[10];
int               ArrayCounter;
//Totals variables
int               Trades, Winners, Losers, Be, PipsProfit;
double            Profit;
//Label positions
double            horizontal, vertical;
      
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   

   //Turn user inputs into an Array
   CreateArray();
   
   // Force display at start up, so EA will do analysis even when broker is closed
   OrdersInHistory = 0;
   start();
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {

    Comment("");
    ObjectsDeleteAll(0, OBJ_LABEL);
    return(0);

  }

void Printtxt(string text, string str,int size, string font, color vcolor, double vertical, double horizontal) 
{
   //if (ObjectFind(str) != 0)
   if (ObjectFind(str) == -1)
   {
      ObjectCreate(str, OBJ_LABEL, 0, 0, 0);      
   }
   ObjectSetText(str, text, size, font, vcolor);
   ObjectSet(str, OBJPROP_XDISTANCE, 0 + horizontal);
   ObjectSet(str, OBJPROP_YDISTANCE, 0 + 14.0 * vertical);
   
}//End void Printtxt(string text, string str,int size, string font, color vcolor = -1, double vertical = -1.0, int horizontal = 0) {
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+


void CreateArray()
{
   ArrayCounter = -1;
   
   if (MagicNumber1 > -1)
   {
      ArrayCounter++;
      MagicNumber[ArrayCounter] = MagicNumber1;
      Description[ArrayCounter] = Description1;
   }
   
   if (MagicNumber2 > -1)
   {
      ArrayCounter++;
      MagicNumber[ArrayCounter] = MagicNumber2;
      Description[ArrayCounter] = Description2;
   }
   
   if (MagicNumber3 > -1)
   {
      ArrayCounter++;
      MagicNumber[ArrayCounter] = MagicNumber3;
      Description[ArrayCounter] = Description3;
   }
   
   if (MagicNumber4 > -1)
   {
      ArrayCounter++;
      MagicNumber[ArrayCounter] = MagicNumber4;
      Description[ArrayCounter] = Description4;
   }
   
   if (MagicNumber5 > -1)
   {
      ArrayCounter++;
      MagicNumber[ArrayCounter] = MagicNumber5;
      Description[ArrayCounter] = Description5;
   }
   
   if (MagicNumber6 > -1)
   {
      ArrayCounter++;
      MagicNumber[ArrayCounter] = MagicNumber6;
      Description[ArrayCounter] = Description6;
   }
   
   if (MagicNumber7 > -1)
   {
      ArrayCounter++;
      MagicNumber[ArrayCounter] = MagicNumber7;
      Description[ArrayCounter] = Description7;
   }
   
   if (MagicNumber8 > -1)
   {
      ArrayCounter++;
      MagicNumber[ArrayCounter] = MagicNumber8;
      Description[ArrayCounter] = Description8;
   }
   
   if (MagicNumber9 > -1)
   {
      ArrayCounter++;
      MagicNumber[ArrayCounter] = MagicNumber9;
      Description[ArrayCounter] = Description9;
   }
   
   if (MagicNumber10 > -1)
   {
      ArrayCounter++;
      MagicNumber[ArrayCounter] = MagicNumber10;
      Description[ArrayCounter] = Description10;
   }
   

}//void CreateArray()


void AnalyseTrades()
{
   //Analyses history by magic number and purs the info into ScreenMessage for later display
   
   //Headings
   vertical = DisplayVerticalStart;
   horizontal = DisplayHorizontalStart + HorizontalIncrement * 3.5; 
     
   string Label_Name;
      
   Label_Name = "headlabel" + "a";
   Printtxt("Trades",Label_Name,FontSize,"Arial", PairColour,vertical,horizontal);
   horizontal+= HorizontalIncrement; 
   
   Label_Name = "headlabel" + "b";
   Printtxt("Wins",Label_Name,FontSize,"Arial", WinColour,vertical,horizontal);
   horizontal+= HorizontalIncrement; 
   
   Label_Name = "headlabel" + "c";
   Printtxt("Loss",Label_Name,FontSize,"Arial", LossColour,vertical,horizontal);
   horizontal+= HorizontalIncrement; 
   
   Label_Name = "headlabel" + "d";
   Printtxt("Be",Label_Name,FontSize,"Arial", BreakevenColour,vertical,horizontal);
   horizontal+= HorizontalIncrement; 
   
   Label_Name = "headlabel" + "e";
   Printtxt("Pips",Label_Name,FontSize,"Arial", PairColour,vertical,horizontal);
   horizontal+= HorizontalIncrement; 
   
   Label_Name = "headlabel" + "f";
   Printtxt("Profit",Label_Name,FontSize,"Arial", PairColour,vertical,horizontal);
   horizontal+= HorizontalIncrement; 
   

   for (int ac = 0; ac <= ArrayCounter; ac++)
   {
      if (MagicNumber[ac] > -1)
      {
         Trades = 0; Winners = 0; Losers = 0; Be = 0; PipsProfit = 0;
         Profit = 0;
         for (int cc=0; cc < OrdersHistoryTotal(); cc++)
         {
            OrderSelect(cc, SELECT_BY_POS, MODE_HISTORY);
            if (OrderMagicNumber() == MagicNumber[ac] && (OrderType() == OP_BUY || OrderType() == OP_SELL) )
            {
               Profit = Profit + OrderProfit();
               Trades++;
               if (OrderProfit() > 0) Winners ++;
               if (OrderProfit() == 0) Be ++;
               if (OrderProfit() < 0) Losers ++;
               if (OrderType() == OP_BUY) double trade = CalculatePipsProfit(OrderClosePrice(), OrderOpenPrice() );
               if (OrderType() == OP_SELL) trade = CalculatePipsProfit(OrderOpenPrice(), OrderClosePrice() );
               PipsProfit += (trade);         
            }//if (OrderMagicNumber() = MagicNumber
      
         }//for (int cc=0; cc < OrdersHistoryTotal(); cc++)
         if (Digits == 3 || Digits == 5) PipsProfit /= 10;
   
         ShowData(MagicNumber[ac], Description[ac]);
      }//if (MagicNumber[ac] > -1)
      
   }//for (int ac = 0; ac < ArrayCounter; ac++)
    
   

}//End void AnalyseTrades



int CalculatePipsProfit(double trade1, double trade2)
{

   int multiplier;
   if (MarketInfo(OrderSymbol(), MODE_DIGITS) == 2) multiplier = 100;
   if (MarketInfo(OrderSymbol(), MODE_DIGITS) == 3) multiplier = 1000;
   if (MarketInfo(OrderSymbol(), MODE_DIGITS) == 4) multiplier = 10000;
   if (MarketInfo(OrderSymbol(), MODE_DIGITS) == 5) multiplier = 100000;
   
   double pips = (trade1 - trade2) * multiplier;
   return (pips);

}//int CalculatePipsProfit(double trade1, double trade2)


void ShowData(int mn, string det)
{

      string Label_Name;
      static int update;
      vertical+= VerticalIncrement;



      //Details
      horizontal = DisplayHorizontalStart;
      Label_Name = "detaillabel" + DoubleToStr(update,0) + "x";
      Printtxt(mn,Label_Name,FontSize,"Arial", PairColour,vertical,horizontal);
      horizontal+= HorizontalIncrement * 1.5; 
      update++;
      
      Label_Name = "detaillabel" + DoubleToStr(update,0) + "x";
      Printtxt(det, Label_Name, FontSize, "Arial", PairColour,vertical,horizontal);
      horizontal+= HorizontalIncrement * 2; 
      update++;
      
      Label_Name = "detaillabel" + DoubleToStr(update,0) + "x";
      Printtxt(DoubleToStr(Trades, 0), Label_Name, FontSize, "Arial", TradesColour,vertical,horizontal);
      horizontal+= HorizontalIncrement; 
      update++;
      
      Label_Name = "detaillabel" + DoubleToStr(update,0) + "x";
      Printtxt(DoubleToStr(Winners, 0), Label_Name, FontSize, "Arial", WinColour,vertical,horizontal);
      horizontal+= HorizontalIncrement; 
      update++;
      
      Label_Name = "detaillabel" + DoubleToStr(update,0) + "x";
      Printtxt(DoubleToStr(Losers, 0), Label_Name, FontSize, "Arial", LossColour,vertical,horizontal);
      horizontal+= HorizontalIncrement; 
      update++;
      
      Label_Name = "detaillabel" + DoubleToStr(update,0) + "x";
      Printtxt(DoubleToStr(Be, 0), Label_Name, FontSize, "Arial", BreakevenColour,vertical,horizontal);
      horizontal+= HorizontalIncrement; 
      update++;
      
      Label_Name = "detaillabel" + DoubleToStr(update,0) + "x";
      color col;
      if (PipsProfit > 0) col = WinColour;
      if (PipsProfit < 0) col = LossColour;
      if (PipsProfit == 0) col = BreakevenColour;
      Printtxt(DoubleToStr(PipsProfit, 0), Label_Name, FontSize, "Arial", col,vertical,horizontal);
      horizontal+= HorizontalIncrement; 
      update++;
      
      Label_Name = "detaillabel" + DoubleToStr(update,0) + "x";
      if (Profit > 0) col = WinColour;
      if (Profit < 0) col = LossColour;
      if (Profit == 0) col = BreakevenColour;
      Printtxt(DoubleToStr(Profit, 2), Label_Name, FontSize, "Arial", col,vertical,horizontal);
      horizontal+= HorizontalIncrement; 
      update++;
      
      


}//void ShowData(int mn, string det);
   

int start()
  {
//----
      
      if (OrdersHistoryTotal() == 0)
      {
         Comment("No trades in the history tab");
         return;
      }//if (OrdersHistoryTotal() == 0)
      
      
      
      if (OrdersInHistory != OrdersHistoryTotal())
      {
         ObjectsDeleteAll(0, OBJ_LABEL);
         AnalyseTrades();
         OrdersInHistory = OrdersHistoryTotal();
      }//if (OrdersInHistory != OrdersHistoryTotal())
         
//----
   return(0);
  }
//+------------------------------------------------------------------+