//+------------------------------------------------------------------+
//|         Steve Hopwood's BS Asian session breakout multi-pair.mq4 |
//|                                                                  |
//|                                                                  |
//+------------------------------------------------------------------+

#property show_inputs
#include <WinUser32.mqh>
#include <stdlib.mqh>
#define  NL    "\n"
#define  gv_high "SH BS Asian session High "
#define  gv_low "SH BS Asian session Low "

/*
   RefreshRates();
   double ask = MarketInfo(symbol, MODE_ASK);
   double bid = MarketInfo(symbol, MODE_BID);
   double point = MarketInfo(symbol, MODE_POINT);
   double digits = MarketInfo(symbol, MODE_DIGITS);

void DisplayUserFeedback()
void AdjustFor4digitCriminal()
start()

----Trading functions----
void LookForOpenTrades()
void SendSingleTrade(int type, string symbol)
bool CheckForHiddenStopLossHit(int type, int iPipsAboveVisual, double stop )  Not used in this robot yet
void GetSpread()
bool ShouldRobotSleep(string symbol)

----Open trade management functions----
void ManageTrades()
void TrailingStopLoss()
void JumpingStopLoss(int ticket) ---- not used in this robot but left in place and commented out in case it is required
void ShouldHalfTradeClose()


----Asia hi-lo----
void Get_Asia_High(string Gv_Name, string symbol)
void Get_Asia_Low(string Gv_Name, string symbol)


********News filter functions***********
Thanks to Tim at FXAW for all this
bool NewsFilterCheck()
      Use construct bool TradeAllowed = NewsFilterCheck()
string Num2Impact(int impact)

----Misc----
void WaitForConnection()

*/




extern string     bs="----Basic stuff----";
extern string     PairsToTrade = "AUDUSD,EURUSD,GBPUSD,USDJPY";
extern double     Lot=0.02;
extern int        MagicNumber=283505;
extern string     TradeComment="BS Asian breakout";
extern int        MaxSpread=120;
extern int        StopLossPips=200;
extern int        HalfClosePips=200;
extern int        BEP=10;
extern int        SleepAfterTradeClosesMins=60;
extern int        MaxTradingPipsFromHiLo=200;
extern string     ast="----Asian session times in your local time 24h clock----";
extern int        Asia_Start_Hour=22;
extern int        Asia_End_Hour=7;
extern string     lst="----London session times in your local time 24h clock----";
extern int        Europe_Start_Hour=7;
extern int        Europe_End_Hour=16;
extern string     trs="----Trading style----";
extern bool       SendImmediateMarketOrder=true;
extern int        Breakout_Pips=100;
extern bool       SendPendingOrder=false;
extern int        PendingOrderPips=100;
extern int        PendingOrderDeleteMins=30;
extern bool       AlertNotTrade=false;
extern string     sls="----Trade management----";
//extern string     JSL="Jumping stop loss";
//extern bool       JumpingStop=false;
//extern int        JumpingStopPips=1000;
//extern bool       AddBEP=true;
//extern int        BreakEvenProfit=100;
//extern bool       HideJumpingStop=false;
//extern int        PipsAwayFromVisualJS=100;
extern string     TSL="Trailing stop loss";
extern int        TrailingStopPips=200;
extern bool       HideTrailingStop=false;
extern int        PipsAwayFromVisualTS=50;
extern string     wei="----Week ending inputs----";
extern bool       FridayClose=true;
extern bool       SaturdayClose=false;
extern int        CloseHour = 12;
extern string     oae="----Odds and ends----";
extern int        DisplayGapSize=30;
extern bool       ShowPairsInformation=true;


//Open trades\trade direction.
bool              TradeExists;
int               NoOfTrades;


//Trading hours
bool              ClosedForFriday;
bool              ClosedForSaturday;

//GV names and hi-lo variables
string            Asian_High_GV;
string            Asian_Low_GV;
double            a_high[], a_low[];
//Pair extraction
string            InputString;//Holds the contents PairsToTrade for tidying yp etc
int               NoOfPairs;// Holds the number of pairs passed by the user via the inputs screen
string            TradePair[]; //Array to hold the pairs traded by the user

//Open trades\trade direction.
bool              TradeOpen;
int               TicketNo;
   

//Misc stuff
string            ScreenMessage, Gap;
bool              RobotDisabled;
string            DisabledMessage;
int               Spread, Decimals;


void DisplayUserFeedback()
{
   ScreenMessage = "";
   ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Trading ", PairsToTrade, NL);
   ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Asian session times: Start: ", DoubleToStr(Asia_Start_Hour, 2), ":  Ends ", DoubleToStr(Asia_End_Hour, 2), NL);
   ScreenMessage = StringConcatenate(ScreenMessage, Gap, "London session times: Start: ", DoubleToStr(Europe_Start_Hour, 2), ":  Ends ", DoubleToStr(Europe_End_Hour, 2), NL);
   ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Lot size = ", Lot, NL);
   ScreenMessage = StringConcatenate(ScreenMessage,Gap, "Magic number = ", MagicNumber, NL);
   ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Trade comment = ", TradeComment, NL);
   ScreenMessage = StringConcatenate(ScreenMessage, Gap, "MaxSpread = ", MaxSpread, NL);
   ScreenMessage = StringConcatenate(ScreenMessage, Gap, "StopLossPips = ", StopLossPips, NL);
   ScreenMessage = StringConcatenate(ScreenMessage, Gap, "HalfClosePips = ", HalfClosePips, ": adding ", BEP, " pips to the breakeven stop loss", NL);
   ScreenMessage = StringConcatenate(ScreenMessage, Gap, "MaxTradingPipsFromHiLo = ", MaxTradingPipsFromHiLo, NL);
   if (SendImmediateMarketOrder) 
   {   
      ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Sending immediate market orders. Breakout pips = ", Breakout_Pips, NL);      
   }//if (SendImmediateMarketOrder) 
   if (SendPendingOrder) ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Sending pending orders.  PendingOrderPips = ", PendingOrderPips, NL);
   ScreenMessage = StringConcatenate(ScreenMessage, Gap, "SleepAfterTradeClosesMins = ", SleepAfterTradeClosesMins, NL);
   if (FridayClose) ScreenMessage= StringConcatenate(ScreenMessage, Gap, "Friday close = ", DoubleToStr(CloseHour, 2), NL);
   if (SaturdayClose) ScreenMessage= StringConcatenate(ScreenMessage, Gap, "Saturday close = ", DoubleToStr(CloseHour, 2), NL);
   
   /*  
   if(JumpingStop==true)
   {
      ScreenMessage = StringConcatenate(ScreenMessage,  NL, Gap, "Jumping stop set to ", JumpingStopPips);
      if (HideJumpingStop)  ScreenMessage = StringConcatenate(ScreenMessage, " (HideJumpingStop = true: PipsAwayFromVisualJS = ", PipsAwayFromVisualJS, ")");
      if(AddBEP==true)
      {
         ScreenMessage = StringConcatenate(ScreenMessage, ", also adding BreakEvenProfit (", BreakEvenProfit, " pips)");      
      }      
   }
   else
   {
      ScreenMessage = StringConcatenate(ScreenMessage, NL, Gap, "Jumping stop disabled");
   }
   ScreenMessage = StringConcatenate(ScreenMessage, Gap, NL);
   */

   ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Trailing stop pips = ", TrailingStopPips, NL);
   if (HideTrailingStop) ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Hiding the trailint stop. PipsAwayFromVisualTS = ", PipsAwayFromVisualTS, NL);
   
   ScreenMessage= StringConcatenate(ScreenMessage, NL);

   if (ShowPairsInformation)
   {
      for (int cc = 0; cc < NoOfPairs; cc++)
      {
         string symbol = TradePair[cc];
         int digits = MarketInfo(symbol, MODE_DIGITS);
         double ask = MarketInfo(symbol, MODE_ASK);
         double bid = MarketInfo(symbol, MODE_BID);
         Asian_High_GV = gv_high + symbol;
         Asian_Low_GV = gv_low + symbol;
         //double highest = GlobalVariableGet(Asian_High_GV);
         //double lowest = GlobalVariableGet(Asian_Low_GV);
         double highest = a_high[cc];
         double lowest = a_low[cc];
         ScreenMessage = StringConcatenate(ScreenMessage, Gap, symbol, 
                         ": High = ", DoubleToStr(highest, digits),
                         ": Low = ", DoubleToStr(lowest, digits),
                         ": Ask = ", DoubleToStr(ask, digits),
                         ": Bid = ", DoubleToStr(bid, digits),
                         NL);
      }//for (cc = 0; cc < NoOfCurrencies; cc==)
   }//if (ShowPairsInformation)
   

   Comment(ScreenMessage);
}//void DisplayUserFeedback()


//+------------------------------------------------------------------+
//| expert Initialization function                                   |
//+------------------------------------------------------------------+

int init()
  {

   if (!IsDemo() )
   {
      if (MagicNumber == 283505)
      {
         MessageBox("You cannot run this robot until changed the MagicNumber input from the default of 283505." + NL 
                    + "Please reload the robot with a new MagicNumber input.");
         Comment("                This robot can do nothing. Please reload it");
         DisabledMessage = "You need to change the MagicNumber input";
         RobotDisabled = true;
         return;
      }//if (MagicNumber == 4872635)
      
      //Insufficient length
      string mn = DoubleToStr(MagicNumber,0);
      if (StringLen(mn) < 5)
      {
         MessageBox("Your MagicNumber input needs to be at least 5 digits long, Your MagicNumber is " + mn + NL 
                    + "Please reload the robot with the MagicNumber input containing at least 5 digits - the more the better.");
         Comment("                This robot can do nothing. Please reload it");
         DisabledMessage = "You need to make the MagicNumber input at 5 digits long - more is better";
         RobotDisabled = true;
         return;
      }//if (StringLen(mn) < 5)     
      
   }//if (!IsDemo)
   
   
   //Amend inputs to cater for different broker digits
   int dig = MarketInfo(Symbol(), MODE_DIGITS);
   if (dig == 2 || dig == 4)
   {   
      PendingOrderPips/= 10;
      //JumpingStopPips/= 10;
      MaxSpread/= 10;
      Breakout_Pips/= 10;
      StopLossPips/= 10;
      TrailingStopPips/= 10;
      PipsAwayFromVisualTS/= 10;
      MaxTradingPipsFromHiLo/= 10;
      BEP/= 10;
   }//if (dig = 3)
   
   //Extract the pairs traded by the user
   // Cleanup first
   InputString=PairsToTrade;
   CleanUpInputString();
   
   // Extract the number of paraaters passed by the user
   CalculatePairsPassed();
   
   string AddChar = StringSubstr(Symbol(),6,4);
   
   // Resize the arrays appropriately
   string NewArray = ArrayResize(TradePair, NoOfPairs);
   double nhigh1 = ArrayResize(a_high, NoOfPairs);
   double nlow1 = ArrayResize(a_low, NoOfPairs);
   
   int Index = 0;//For searching InputString
   int LastIndex = 0;//Points the the most recent Index
   for (int cc = 0; cc < NoOfPairs; cc ++)
   {
      Index = StringFind(InputString, ",",LastIndex);
      if (Index > -1)
      {
         TradePair[cc] = StringSubstr(InputString, LastIndex,Index-LastIndex);
         TradePair[cc] = StringTrimLeft(TradePair[cc]);
         TradePair[cc] = StringTrimRight(TradePair[cc]);
         TradePair[cc] = StringConcatenate(TradePair[cc], AddChar);
         
         LastIndex = Index+1;
         
      }//if (Index > -1)            
   }//for (int cc; cc<NoOfPairs; cc ++)

    int Step = MarketInfo(Symbol(),MODE_LOTSTEP);
    
    if(Step == 0.01) Decimals = 2;
    if(Step == 0.10) Decimals = 1;
    if(Step == 1.00) Decimals = 0;
    
    
   Gap="";
   if (DisplayGapSize >0)
   {
      for (cc=0; cc< DisplayGapSize; cc++)
      {
         Gap = StringConcatenate(Gap, " ");
      }   
   }
   
   GetPosition();   
   
   AdjustFor4digitCriminal();
      
   Comment(".........Waiting for a tick");
   
   return(0);
    
  }
  
//+------------------------------------------------------------------+
//| expert Deinitialization function                                 |
//+------------------------------------------------------------------+

int deinit()
  {

    Comment("");
    
    return(0);

  }
  
//+------------------------------------------------------------------+
//| expert GetPosition function                                      |
//+------------------------------------------------------------------+

void AdjustFor4digitCriminal()
{

   if (Digits == 2 || Digits == 4)
   {
      //JumpingStopPips/= 10;
      //BreakEvenProfit/= 10;
      //PipsAwayFromVisualJS/= 10;
      PipsAwayFromVisualTS/= 10;
      MaxSpread/= 10;
      PendingOrderPips/= 10;
      //MinStopLoss/= 10;
   }//if (Digits == 2 || Digits == 4)

}//void AdjustFor4digitCriminal()

void GetPosition()
{

   NoOfTrades = 0;
   if (OrdersTotal() == 0 ) return;
   
   for(int cc = OrdersTotal() - 1; cc >= 0; cc--)
   {
       if(!OrderSelect(cc, SELECT_BY_POS, MODE_TRADES) ) continue;
         
       if(OrderMagicNumber() == MagicNumber)
       {
           NoOfTrades++;
       }//if(OrderSymbol() == symbol && OrderMagicNumber() == MagicNumber)
         
   }//for(int cc = 0; cc <= OrdersTotal(); cc++)
 
 
}//void GetPosition(string symbol)



/*
//+------------------------------------------------------------------+
//| expert News function                                             |
//+------------------------------------------------------------------+  

bool NewsExist()
  {
  
    bool News;

    for(int d = 0; d < NoOfPairs; d++)
      {
        int MinutesSincePrevEvent =
          iCustom(NULL,0,"Economic News",TradePair[d],true,false,false,true,true,1,0);

        int MinutesUntilNextEvent =
          iCustom(NULL,0,"Economic News",TradePair[d],true,false,false,true,true,1,1);

        if(MinutesUntilNextEvent < 60 ||
           MinutesSincePrevEvent < 15)
          {
            News = true;
          }
      }
      
    return(News);

  }
*/
//+------------------------------------------------------------------+
//| expert Trend function                                            |
//+------------------------------------------------------------------+  


void CleanUpInputString()
{
   // Does any tidying up of the user inputs
   
   //Remove unwanted spaces
   InputString = StringTrimLeft(InputString);
   InputString = StringTrimRight(InputString);

   //Add final comma if ommitted by user
   if (StringSubstr(InputString, StringLen(InputString)-1) != ",") 
      InputString = StringConcatenate(InputString,",");
      
   
}//void CleanUpInputString

void CalculatePairsPassed()
{
   // Calculates the numbers of paramaters passed in LongMagicNumber and TradeComment.
   
   int Index = 0;//For searching NoTradePairs
   int LastIndex;//Points the the most recent Index
   
   NoOfPairs = 0;
   while(Index > -1)
      {
         Index = StringFind(InputString, ",",LastIndex);
         if (Index > -1)
         {
            NoOfPairs ++;
            LastIndex = Index+1;            
         }//if (Index > -1)
      }//while(int cc > -1)
   
   
   
}//End void CalculatePairsPassed()





void ShouldHalfTradeClose()
{
   //Only called if selected trade is in profit/
   //Closes half the trade at profit of risk x 2
   
   if (!IsTradeAllowed() ) return;
   
   RefreshRates();
   double ask = MarketInfo(OrderSymbol(), MODE_ASK);
   double bid = MarketInfo(OrderSymbol(), MODE_BID);
   double point = MarketInfo(OrderSymbol(), MODE_POINT);
   double digits = MarketInfo(OrderSymbol(), MODE_DIGITS);
   
   string symbol = OrderSymbol();
   
   //Long
   if (OrderType() == 0)
   {
      double HcPrice = NormalizeDouble(OrderOpenPrice() + (HalfClosePips * point), digits);//Half close price
      if (ask > HcPrice)
      {
        bool result = OrderClose(OrderTicket(),OrderLots() / 2, OrderClosePrice(),100,CLR_NONE);
        if (!result)
        {
             int err=GetLastError();
             Alert(symbol, " BS Asian session breakout ", OrderType()," part-close failed with error(",err,"): ",ErrorDescription(err));
             return;
        }//if (!result)
        //Get new ticket number
        Sleep(100);
        DoesTradeExist(symbol );
        OrderSelect(TicketNo, SELECT_BY_TICKET);
        if (OrderStopLoss() < OrderOpenPrice() )
        {
           double SL = NormalizeDouble(OrderOpenPrice() + (BEP * point), digits);           
           result = OrderModify(OrderTicket(), OrderOpenPrice(), SL, OrderTakeProfit(), 0, CLR_NONE);
           if (!result)
            {
                err=GetLastError();
                Alert(symbol, " BS Asian session breakout ", OrderType(), " Stop loss move failed with error(",err,"): ",ErrorDescription(err));
                return;
            }//if (!result)     
        }//if (OrderStopLoss() < OrderOpenPrice() )
     }//if (Ask > HcPrice)      
   }//if (OrderType() == 0)
   
   //Short
   if (OrderType() == 1)
   {
      HcPrice = NormalizeDouble(OrderOpenPrice() - (HalfClosePips * point), digits);//Half close price
      if (bid < HcPrice)
      {
         result = OrderClose(OrderTicket(),OrderLots() / 2, OrderClosePrice(),100,CLR_NONE);
         if (!result)
         {
             err=GetLastError();
             Alert(symbol, " BS Asian session breakout ", OrderType()," part-close failed with error(",err,"): ",ErrorDescription(err));
             return;
         }//if (!result)
        //Get new ticket number
        Sleep(100);
        DoesTradeExist(symbol );
        OrderSelect(TicketNo, SELECT_BY_TICKET);
        if (OrderStopLoss() < OrderOpenPrice() )
        {
           SL = NormalizeDouble(OrderOpenPrice() - (BEP * point), digits);
           result = OrderModify(OrderTicket(), OrderOpenPrice(), SL, OrderTakeProfit(), 0, CLR_NONE);
           if (!result)
            {
                err=GetLastError();
                Alert(symbol, " BS Asian session breakout ", OrderType(), " Stop loss move failed with error(",err,"): ",ErrorDescription(err));
                return;
            }//if (!result)     
        }//if (OrderStopLoss() < OrderOpenPrice() ) 
      }//if (Bid < HcPrice)      
   }//if (OrderType() == 1)
   

}//void ShouldHalfTradeClose()

void ManageTrades()
{
   //Called if there are any open trades
   for (int cc = OrdersTotal() - 1; cc >=0; cc--)
   {
      if (!OrderSelect(cc, SELECT_BY_POS) ) continue;
      if (OrderMagicNumber() ==  MagicNumber)
      {
         double digits = MarketInfo(OrderSymbol(), MODE_DIGITS);
         double point = MarketInfo(OrderSymbol(), MODE_POINT);
         TicketNo = OrderTicket();
         /*if (JumpingStop)
         {
            JumpingStopLoss(TicketNo);
         }//if (JumpingStop)
         */
         
         //Trailing stop
         TrailingStopLoss();
         
         //Partial trade closure
         OrderSelect(TicketNo, SELECT_BY_TICKET);//Should not need re-selecting, but just in case
         if (OrderCloseTime() == 0 && OrderProfit() > 0 && OrderLots() == Lot)
         {
            ShouldHalfTradeClose();
         }//if (OrderCloseTime() == 0 && OrderProfit() > 0)
      
         //Pick up on any failed stop move to breakeven
         if (OrderType() == OP_BUY)
         {
            if (OrderLots() < Lot && OrderStopLoss() < OrderOpenPrice() )
            {
               OrderModify(TicketNo, OrderOpenPrice(), NormalizeDouble(OrderOpenPrice() + (BEP * point), digits), OrderTakeProfit(), OrderExpiration(), CLR_NONE);
            }//if (OrderLots() < Lot && OrderStopLoss() < OrderOpenPrice() )            
         }//if (OrderType() == OP_BUY)
         
         if (OrderType() == OP_SELL)
         {
            if (OrderLots() < Lot && OrderStopLoss() > OrderOpenPrice() )
            {
               OrderModify(TicketNo, OrderOpenPrice(), NormalizeDouble(OrderOpenPrice() - (BEP * point), digits), OrderTakeProfit(), OrderExpiration(), CLR_NONE);
            }//if (OrderLots() < Lot && OrderStopLoss() < OrderOpenPrice() )            
         }//if (OrderType() == OP_SELL)
         
      }//if (symbol == symbol && OrderMagicNumber() ==  MagicNumber)      
   }//for (int cc = OrdersTotal() - 1; cc >=0)

   
   
}//void ManageTrades()


void DoesTradeExist(string symbol)
{
   //Searches for open trades
   TradeExists = false;
   TicketNo = 0;
   
   
   if (OrdersTotal() == 0) return; //nothing to do
   
   for (int cc = OrdersTotal() - 1; cc >= 0; cc--)
   {
      if (!OrderSelect(cc, SELECT_BY_POS) ) continue;
      if (OrderMagicNumber() == MagicNumber && OrderSymbol() == symbol ) 
      {
         TicketNo = OrderTicket();
         TradeExists = true;
         return;         
      }//if (OrderMagicNumber() == MagicNumber && OrderSymbol() == symbol)       
   }//for (int cc = OrdersTotal() - 1; cc >= 0, cc--)  
   
}//End void DoesTradeExist(string symbol)



void SendSingleTrade(int type, string symbol)
{
   // Attempts to place a trade according to type, i.e.
   // 0 = OP_BUY
   // 1 = OP_SELL
   
   // Check spread
   if (MarketInfo(symbol, MODE_SPREAD) > MaxSpread)
   {
      return(false);// Spread too large, so abort send
   }//if (MarketInfo(NULL, MODE_SPREAD) > MaxSpreadAllowed)
   
   RefreshRates();
   double ask = MarketInfo(symbol, MODE_ASK);
   double bid = MarketInfo(symbol, MODE_BID);
   double point = MarketInfo(symbol, MODE_POINT);
   double digits = MarketInfo(symbol, MODE_DIGITS);
   
   double StopLoss;
      
   // Buy trade
   if (type == 0)
   {
      double TradePrice=ask;
      int colour = 32768;//green
      StopLoss = NormalizeDouble(TradePrice - (StopLossPips * point), digits );
      datetime expiry = 0;
   }//if (type == 0)   
   
   //Buy stop trade
   if (type == OP_BUYSTOP)
   {
      TradePrice = NormalizeDouble(ask + (PendingOrderPips * point), digits);
      StopLoss = NormalizeDouble(TradePrice - (StopLossPips * point), digits );
      colour = 32768;//green
      expiry = TimeCurrent()+(PendingOrderDeleteMins*60);
   }//if (type == 4)

   // Sell trade
   if (type == 1)
   {
      TradePrice=bid;      
      StopLoss = NormalizeDouble(TradePrice + (StopLossPips * point), digits );
      colour = 255;//red
      expiry = 0;
   }//if (type == 1)
   
   //Sell stop trade
   if (type == OP_SELLSTOP)
   {
      TradePrice = NormalizeDouble(bid - (PendingOrderPips * point), digits);
      StopLoss = NormalizeDouble(TradePrice + (StopLossPips * point), digits );
      colour = 255;//red
      expiry = TimeCurrent()+(PendingOrderDeleteMins*60);
   }//if (type == 4)
   
   int slippage = 10;
   if (digits == 3 || digits == 5) slippage = 100;
   
   int ticket = OrderSend(symbol,type, Lot, TradePrice, slippage, StopLoss, 0, TradeComment, MagicNumber,expiry, colour);
   if (ticket < 0)
   {
      int err=GetLastError();
      if (err == 130) return;
      Alert("5mm multi-trade ", symbol, " ", type," order send failed with error(",err,"): ",ErrorDescription(err));
      Print("Order send failed with error(",err,"): ",ErrorDescription(err));
      Sleep(5000);
      return(false);
   }//if (ticket < 0)
   else Sleep(5000);//5 seconds
   
   return(true);
   
}//End void SendSingleTrade(int type, string symbol)


bool CheckForHiddenStopLossHit(int type, int iPipsAboveVisual, double stop)
{
   //Reusable code that can be called by any of the stop loss manipulation routines except HiddenStopLoss().
   //Checks to see if the market has hit the hidden sl and attempts to close the trade if so. 
   //Returns true if trade closure is successful, else returns false

   RefreshRates();
   double ask = MarketInfo(OrderSymbol(), MODE_ASK);
   double bid = MarketInfo(OrderSymbol(), MODE_BID);
   double point = MarketInfo(OrderSymbol(), MODE_POINT);
   double digits = MarketInfo(OrderSymbol(), MODE_DIGITS);
   
   //Check buy trade
   if (type == OP_BUY)
   {
      double sl = NormalizeDouble(stop + (iPipsAboveVisual * point), digits);
      if (bid <= sl)
      {
         bool result = OrderClose(OrderTicket(), OrderLots(), OrderClosePrice(), 5, CLR_NONE);
         if (result)
         {
            Alert("Stop loss hit. Close of ", OrderSymbol(), " ticket no ", OrderTicket());      
         }//if (result)
         else
         {
            int err=GetLastError();
            Alert("Stop loss hit. Close of ", OrderSymbol(), " ticket no ", OrderTicket()," failed with error (",err,"): ",ErrorDescription(err));
            Print("Stop loss hit. Close of ", OrderSymbol(), " ticket no ", OrderTicket()," failed with error (",err,"): ",ErrorDescription(err));
         }//else
      }//if (bid <= sl)  
   }//if (type = OP_BUY)
   
   //Check buy trade
   if (type == OP_SELL)
   {
      sl = NormalizeDouble(stop - (iPipsAboveVisual * point), digits);
      if (ask >= sl)
      {
         result = OrderClose(OrderTicket(), OrderLots(), OrderClosePrice(), 5, CLR_NONE);
         if (result)
         {
            Alert("Stop loss hit. Close of ", OrderSymbol(), " ticket no ", OrderTicket());      
         }//if (result)
         else
         {
            err=GetLastError();
            Alert("Stop loss hit. Close of ", OrderSymbol(), " ticket no ", OrderTicket()," failed with error (",err,"): ",ErrorDescription(err));
            Print("Stop loss hit. Close of ", OrderSymbol(), " ticket no ", OrderTicket()," failed with error (",err,"): ",ErrorDescription(err));
         }//else
      }//if (ask >= sl)  
   }//if (type = OP_SELL)
   

}//End bool CheckForHiddenStopLossHit(int type, int iPipsAboveVisual, double stop)

/*
void JumpingStopLoss(int ticket) 
{
   if (!OrderSelect(ticket, SELECT_BY_TICKET) ) return;//Order has closed, so nothing to do

   RefreshRates();
   double ask = MarketInfo(OrderSymbol(), MODE_ASK);
   double bid = MarketInfo(OrderSymbol(), MODE_BID);
   double point = MarketInfo(OrderSymbol(), MODE_POINT);
   double digits = MarketInfo(OrderSymbol(), MODE_DIGITS);
  
   double sl=OrderStopLoss(); //Stop loss

   if (OrderType()==OP_BUY)
   {
      //Check hidden js for trade closure
      if (HideJumpingStop)
      {
         bool TradeClosed = CheckForHiddenStopLossHit(OP_BUY, PipsAwayFromVisualJS, OrderStopLoss() );
         if (TradeClosed) return;//Trade has closed, so nothing else to do
      }//if (HideJumpingStop)
      
      // First check if sl needs setting to breakeven
      if (sl==0 || sl<OrderOpenPrice())
      {
         if (ask >= OrderOpenPrice() + (JumpingStopPips*point))
         {
            sl=OrderOpenPrice();
            if (AddBEP==true) sl=sl+(BreakEvenProfit*point); // If user wants to add a profit to the break even
            bool result = OrderModify(OrderTicket(),OrderOpenPrice(),sl,OrderTakeProfit(),0,CLR_NONE);
            if (result)
            {
               Print("Jumping stop set at breakeven: ", OrderSymbol(), ": SL ", sl, ": ask ", ask);
               //Delete the associated hedge trade
               return(0);
            }//if (result)
            if (!result)
            {
               int err=GetLastError();
               Alert(Symbol(), " buy trade. Jumping stop function failed to set SL at breakeven, with error(",err,"): ",ErrorDescription(err));
               Print(Symbol(), " buy trade. Jumping stop function failed to set SL at breakeven, with error(",err,"): ",ErrorDescription(err));
            }//if (!result)
             
            
         }//if (ask >= OrderOpenPrice() + (JumpingStopPips*point))
      } //close if (sl==0 || sl<OrderOpenPrice()

  
      // Increment sl by sl + JumpingStopPips.
      // This will happen when market price >= (sl + JumpingStopPips)
      if (bid>= sl + ((JumpingStopPips*2)*point) && sl>= OrderOpenPrice())      
      {
         sl=sl+(JumpingStopPips*point);
         result = OrderModify(OrderTicket(),OrderOpenPrice(),sl,OrderTakeProfit(),0,CLR_NONE);
         if (result)
         {
            Print("Jumping stop set: ", OrderSymbol(), ": SL ", sl, ": ask ", ask);
            //Delete the associated hedge trade
            return(0);
         }//if (result)
         if (!result)
         {
            err=GetLastError();
            Print(Symbol(), " buy trade. Jumping stop function failed with error(",err,"): ",ErrorDescription(err));
         }//if (!result)
             
      }// if (bid>= sl + (JumpingStopPips*point) && sl>= OrderOpenPrice())      
   }//if (OrderType()==OP_BUY)
   
   if (OrderType()==OP_SELL)
   {
      //Check hidden js for trade closure
      if (HideJumpingStop)
      {
         TradeClosed = CheckForHiddenStopLossHit(OP_SELL, PipsAwayFromVisualJS, OrderStopLoss() );
         if (TradeClosed) return;//Trade has closed, so nothing else to do
      }//if (HideJumpingStop)
            
      // First check if sl needs setting to breakeven
      if (sl==0 || sl>OrderOpenPrice())
      {
         if (ask <= OrderOpenPrice() - (JumpingStopPips*point))
         {
            sl = OrderOpenPrice();
            if (AddBEP==true) sl=sl-(BreakEvenProfit*point); // If user wants to add a profit to the break even
            result = OrderModify(OrderTicket(),OrderOpenPrice(),sl,OrderTakeProfit(),0,CLR_NONE);
            if (result)
            {
               
            }//if (result)
            if (!result)
            {
               err=GetLastError();
               Alert(Symbol(), " sell trade. Jumping stop function failed to set SL at breakeven, with error(",err,"): ",ErrorDescription(err));
               Print(Symbol(), " sell trade. Jumping stop function failed to set SL at breakeven, with error(",err,"): ",ErrorDescription(err));
            }//if (!result)
             
            return(0);
         }//if (ask <= OrderOpenPrice() - (JumpingStopPips*point))
      } // if (sl==0 || sl>OrderOpenPrice()
   
      // Decrement sl by sl - JumpingStopPips.
      // This will happen when market price <= (sl - JumpingStopPips)
      if (bid<= sl - ((JumpingStopPips*2)*point) && sl<= OrderOpenPrice())      
      {
         sl=sl-(JumpingStopPips*point);
         result = OrderModify(OrderTicket(),OrderOpenPrice(),sl,OrderTakeProfit(),0,CLR_NONE);
         if (result)
         {
            Print("Jumping stop set: ", OrderSymbol(), ": SL ", sl, ": ask ", ask);
            
         }//if (result)          
         if (!result)
         {
            err=GetLastError();
            Print(Symbol(), " sell trade. Jumping stop function failed with error(",err,"): ",ErrorDescription(err));
         }//if (!result)

      }// close if (bid>= sl + (JumpingStopPips*point) && sl>= OrderOpenPrice())         
   }//if (OrderType()==OP_SELL)

} //End of JumpingStopLoss sub
*/

void TrailingStopLoss()
{
   if (!OrderSelect(TicketNo, SELECT_BY_TICKET) ) return;
   if (OrderCloseTime() > 0) return;
   if (OrderProfit() < 0) return;//Only trail the stop in profitable trades

   RefreshRates();
   double ask = MarketInfo(OrderSymbol(), MODE_ASK);
   double bid = MarketInfo(OrderSymbol(), MODE_BID);
   double point = MarketInfo(OrderSymbol(), MODE_POINT);
   double digits = MarketInfo(OrderSymbol(), MODE_DIGITS);
   
   if (digits == 2 || digits == 4) TrailingStopPips/= 10;
   
   bool result;
   double sl=OrderStopLoss(); //Stop loss
   double BuyStop=0, SellStop=0;
   
   if (OrderType()==OP_BUY) 
      {
         if (HideTrailingStop)
         {
            bool TradeClosed = CheckForHiddenStopLossHit(OP_BUY, PipsAwayFromVisualTS, OrderStopLoss() );
            if (TradeClosed) return;//Trade has closed, so nothing else to do
         }//if (HideJumpingStop)
		   
		   
		   
		   if (bid >= OrderStopLoss() + (TrailingStopPips*point))
		   {
		       //Breakeven
		       if (OrderStopLoss() < OrderOpenPrice() ) 
		       {
		          sl = OrderOpenPrice();
		       }//if (OrderStopLoss() > OrderOpenPrice() ) 
		       
		       if (bid > sl +  (TrailingStopPips*point))
		       {
		          sl= bid - (TrailingStopPips*point);
		          // Exit routine if user has chosen StopTrailAtPipsProfit and
		          // sl is past the profit Point already
		          result = OrderModify(OrderTicket(),OrderOpenPrice(),sl,OrderTakeProfit(),0,CLR_NONE);
               if (result)
               {
                  Print("Trailing stop updated: ", OrderSymbol(), ": SL ", sl, ": Ask ", ask);
               }//if (result) 
               else
               {
                  int err=GetLastError();
                  Print(Symbol(), " Buy order modify failed with error(",err,"): ",ErrorDescription(err) );
               }//else
   
		       }//if (Bid > sl +  (TrailingStopPips*Point))
		   }//if (Bid >= OrderOpenPrice() + (TrailingStopPips*Point))
      }//if (OrderType()==OP_BUY) 

      if (OrderType()==OP_SELL) 
      {
		   if (ask <= OrderStopLoss() - (TrailingStopPips*point))
		   {
             if (HideTrailingStop)
             {
                TradeClosed = CheckForHiddenStopLossHit(OP_SELL, PipsAwayFromVisualTS, OrderStopLoss() );
                if (TradeClosed) return;//Trade has closed, so nothing else to do
             }//if (HideJumpingStop)
		   
		       //Breakeven
		       if (OrderStopLoss() > OrderOpenPrice() ) 
		       {
		          sl = OrderOpenPrice();
		       }//if (OrderStopLoss() > OrderOpenPrice() ) 

		       if (ask < sl -  (TrailingStopPips*point))
		       {
	               sl= ask + (TrailingStopPips*point);
  	               // Exit routine if user has chosen StopTrailAtPipsProfit and
		            // sl is past the profit Point already
		            result = OrderModify(OrderTicket(),OrderOpenPrice(),sl,OrderTakeProfit(),0,CLR_NONE);
                  if (result)
                  {
                     Print("Trailing stop updated: ", OrderSymbol(), ": SL ", sl, ": Bid ", Bid);
                  }//if (result)
                  else
                  {
                     err=GetLastError();
                     Print(Symbol(), " Sell order modify failed with error(",err,"): ",ErrorDescription(err));
                  }//else
    
		       }//if (Ask < sl -  (TrailingStopPips*Point))
		   }//if (Ask <= OrderOpenPrice() - (TrailingStopPips*Point))
      }//if (OrderType()==OP_SELL) 

   /*
   //Calculate trailing stop pips 
   double TrailingStopPips;
   double PipsAway = 15;
   if (Digits == 3 || Digits == 5) PipsAway*=10;
   
   int multiplier;
   if (Digits == 2) multiplier = 100;
   if (Digits == 3) multiplier = 1000;
   if (Digits == 4) multiplier = 10000;
   if (Digits == 5) multiplier = 100000;

   if (OrderType() == 0)
   {
      int method;
      if (OrderOpenPrice() >= Ema) TrailingStopPips = OrderOpenPrice() - NormalizeDouble(OrderOpenPrice() - (PipsAway * Point),Digits) * multiplier; method = 1;
      if (OrderOpenPrice() < Ema) TrailingStopPips = NormalizeDouble(Ema - (Ema - (PipsAway * Point)), Digits) * multiplier; method = 2;
   }//if (OrderType() == 0)
   
   if (OrderType() == 1)
   {
      if (OrderOpenPrice() <= Ema) TrailingStopPips = NormalizeDouble(OrderOpenPrice() + (PipsAway * Point),Digits) - OrderOpenPrice() * multiplier;
      if (OrderOpenPrice() > Ema) TrailingStopPips = NormalizeDouble(Ema + (PipsAway * Point) - Ema, Digits) * multiplier;
   }//if (OrderType() == 1)
   */

      
} // End of TrailingStopLoss()

void Get_Asia_High(string symbol)
{
   
   double h;  
   
   int highest_bar = iHighest(symbol,PERIOD_H1,MODE_HIGH,9,1);
   h = iHigh(symbol,PERIOD_H1,highest_bar);
   
   GlobalVariableSet(Asian_High_GV, h);
   
}//End void Get_Asia_High(string Gv_Name, string symbol)

void Get_Asia_Low(string symbol)
{
   double l = 1000000000;  
   
   int lowest_bar = iLowest(symbol,PERIOD_H1,MODE_LOW,9,1);
   l = iLow(symbol,PERIOD_H1,lowest_bar);
      
   GlobalVariableSet(Asian_Low_GV, l);
   
}//End void Get_Asia_Low(string Gv_Name, string symbol)

bool ShouldRobotSleep(string symbol)
{
   // Checks the history list to find a closed trade.
   // If one exists, checks to see if it closed more than SleepAfterTradeClosesMins.
   // Returns false (sleep not needed) if so, else true (sleep needed)
   
   if (OrdersHistoryTotal() == 0) return(false);// No history trades, so sleep clearly not needed
   
   for(int cnt = 0; cnt < OrdersHistoryTotal(); cnt++)
   {
      if(!OrderSelect(cnt,SELECT_BY_POS,MODE_HISTORY)) continue;
      {       
         if (OrderSymbol() == symbol && OrderMagicNumber() == MagicNumber)
         {
            int TimePassed = (TimeCurrent() - OrderCloseTime()) / 60;
            if (TimePassed < SleepAfterTradeClosesMins) return(true);//Robot should sleep
         }//if (OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber)            
      }//if(!OrderSelect(cnt,SELECT_BY_POS,MODE_HISTORY))
   }//for(int cnt=0; cnt<OrdersHistoryTotal(); cnt++)

   //Got this far, so sleep not needed
   return(false);

}//End bool ShouldRobotSleep(string symbol)

//+------------------------------------------------------------------+
//| expert Start function                                            |
//+------------------------------------------------------------------+

int start()
{
    
   if (RobotDisabled )
   {
      Comment("The robot has been suspended. Reason: ", DisabledMessage);
      return;
   }//if (RobotDisabled )


   

    GetPosition();
    if(NoOfTrades > 0) ManageTrades();
    
   
    static bool Gvs_deleted = false;
    //Trading hours.    
    //Asian session
    if (TimeHour(TimeLocal() ) >= Asia_Start_Hour && TimeHour(TimeLocal() ) < Asia_End_Hour )
    {
         Comment(Gap, "The Asian session is open, so no trading is possible.");
         //Delete the hi-lo gv's
         if (!Gvs_deleted)
         {
            for(int cc = ArraySize(TradePair); cc >= 0 ; cc--)
            {
               Asian_High_GV = gv_high + TradePair[cc];
               GlobalVariableDel(Asian_High_GV);
               a_high[cc] = 0;
               Asian_Low_GV = gv_low + TradePair[cc];
               GlobalVariableDel(Asian_Low_GV);
               a_low[cc] = 0;
            }//for(int cc = ArraySize(TradePair); cc >= 0 ; cc++)
         }//if (!Gvs_deleted)         
      return;
    }//if (TimeHour(TimeLocal() ) >= Asia_Start_Hour || TimeHour(TimeLocal() ) <= Asia_End_Hour )
    
    //London session
    if (TimeHour(TimeLocal() ) < Europe_Start_Hour && TimeHour(TimeLocal() ) >= Europe_End_Hour)
    {
      Comment("            Outside trading hours. Will continue to manage open trades.");
      return;
    }//if (TimeHour(TimeLocal() < Europe_Start_Hour || TimeHour(TimeLocal() >= Europe_End_Hour)
    
   
    Gvs_deleted = false;
    
    //Look for trading opportunities
    for(cc = 0; cc < ArraySize(TradePair); cc++)
    {

      string symbol = TradePair[cc];//Does nothing more than make typing easier

      //Read Asian session hi-low at the start of the London session
      if (TimeHour(TimeLocal() ) == Europe_Start_Hour)
      {
         Asian_High_GV = gv_high + symbol;
         if (!GlobalVariableCheck(Asian_High_GV) ) 
         {
            Get_Asia_High(symbol);
            a_high[cc] = GlobalVariableGet(Asian_High_GV);
         }//if (!GlobalVariableCheck(Asian_High_GV) ) 
         
         Asian_Low_GV = gv_low + symbol;
         if (!GlobalVariableCheck(Asian_Low_GV) ) 
         {
            Get_Asia_Low(symbol);
            a_low[cc] = GlobalVariableGet(Asian_Low_GV);
         }//if (!GlobalVariableCheck(Asian_Low_GV) ) 
         
      }//if (TimeHour(TimeLocal() ) == Europe_Start_Hour)
      
   
      
      //Check for open trades. Their ticket numbers are stored in variables set up for the purpose
      DoesTradeExist(symbol);

   
     //Check Friday close
     if (FridayClose)
     {
        ClosedForFriday = false;
        if (TimeHour(TimeLocal() ) >= CloseHour && TimeDayOfWeek(TimeLocal() ) == 5)
        {
           ClosedForFriday = true;
           DisplayUserFeedback();
           return;
        }//if (TimeHour(TimeLocal()) >= CloseHour && DayOfWeek() == 5)
     }//if (FridayClose)
        
     //Check Saturday close for Aitipodeans
     if (SaturdayClose)
     {
        ClosedForSaturday = false;
        if (TimeHour(TimeLocal() ) >= CloseHour && TimeDayOfWeek(TimeLocal() ) == 6)
        {
           ClosedForSaturday = true;
           DisplayUserFeedback();
           return;
        }//if (TimeHour(TimeLocal()) >= CloseHour && DayOfWeek() == 5)
     }//if (Saturday)

      
            
       if (!IsTradeAllowed())
       {
            Comment("Trading disabled by the criminal pillock. Please wait for him to get out of bed.");
            return;
       }//if (!IsTradeAllowed)
       
      //Trading hours
      bool TradeHour = false;
      
 
       if(iClose(TradePair[cc],0,0) > 0)
       {      
            if (a_high[cc] == 0) 
            {   
               Asian_High_GV = gv_high + symbol;
               a_high[cc] = GlobalVariableGet(Asian_High_GV);//In case of a restart
            }//if (a_high[cc] == 0) 
            
            if (a_low[cc] == 0) 
            {
               Asian_Low_GV = gv_low + symbol;
               a_low[cc] = GlobalVariableGet(Asian_Low_GV);//In case of a restart
            }//if (a_low[cc] == 0) 
               
            if (TradeExists) continue;
            
            //Overriding filters ok, so continue
            bool TradeAllowed = true;
            
            if (TradeExists) TradeAllowed = false;
            
            
            //Abort if trading has been disallowed for any reason
            if (!TradeAllowed) continue;
            
         //Check for sleep time after trade closure for any reason
        if (!TradeExists)
        {
           bool SendToSleep = ShouldRobotSleep(symbol);// Compares closure time of history trade with current time, 
                                                 // returning true for sleep or false. Will return false if no history trades
           if (SendToSleep)
           {
              continue;
           }//if (SendToSleep)
        }//if (!TradeExists)
           
            if (IsTradeAllowed() )
            {                    
               
               RefreshRates();
               double ask = MarketInfo(symbol, MODE_ASK);
               double bid = MarketInfo(symbol, MODE_BID);
               double point = MarketInfo(symbol, MODE_POINT);
               double digits = MarketInfo(symbol, MODE_DIGITS);
               
               if (ask > (a_high[cc] + Breakout_Pips * point) && a_high[cc] != 0 && a_high[cc] < (a_high[cc] + MaxTradingPipsFromHiLo * point) )
               {
                  if (AlertNotTrade) Alert("BS Asian session breakout ", symbol, " Long trade is available");
                  else
                  {
                     if (SendImmediateMarketOrder) SendSingleTrade(0, symbol);
                     if (SendPendingOrder) SendSingleTrade(OP_BUYSTOP, symbol);
                  }//else               
               }//if (ask > (a_high[cc] + Breakout_Pips * point) && a_high[cc] != 0)
      
               if (bid < (a_low[cc] - Breakout_Pips * point) && a_low[cc] != 0 && a_low[cc] > (a_low[cc] - MaxTradingPipsFromHiLo * point) )
               {
                  if (AlertNotTrade) Alert("BS Asian session breakout ", symbol, " Short trade is available");
                  else
                  {               
                     if (SendImmediateMarketOrder) SendSingleTrade(1, symbol);
                     if (SendPendingOrder) SendSingleTrade(OP_SELLSTOP, symbol);
                  }//else
               }//if (Ask - HighestSma > 10 * Point) TradeDirection = long;         
               
            }//if (IsTradeAllowed)        
            
         }//if(iClose(TradePair[cc],0,0) > 0)
      
      }//for(int cc = 0; cc < ArraySize(TradePair); cc++)
    
    DisplayUserFeedback();
      
    return(0);

}//End start()


